; Broadcom 802.11 Network Adapter Setup DriverOnly installer configuration file
; Copyright (C) 2010, Broadcom Corp.

[Version]
Signature="$Windows NT$"

[Setup]
DefaultInstallPath	= %16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver
UninstallLog		= %16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\uninstall.log
DriverStore		= %16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver
SupportedOS		= 5x

[Install]
ConditionalSection	= gsmu.upgrade,gsmu.driver.upgrade
UninstallLog		= uninstall.log
DriverInf		= bcmwl5.inf
CopyFiles		= install.copyfiles, help.copyfiles, %LocalizedHelpSection%
AddReg			= install.addreg, addremove.addreg

[Install.amd64]
ConditionalSection	= gsmu.upgrade,gsmu.driver.upgrade
UninstallLog		= uninstall.log
DriverInf		= bcmwl5.inf
CopyFiles		= install.copyfiles, help.copyfiles, %LocalizedHelpSection%
AddReg			= install.addreg, addremove.addreg.amd64

[cond.driver]

[install.driver]

[Upgrade]
DelReg =	install.delreg

[Uninstall]
DelReg =	install.delreg

[install.copyfiles.amd64]
bcmwlu00.exe,,,	0x00000006
bcmwls64.exe,,,	0x00000006

[install.copyfiles]
bcmwlu00.exe,,,	0x00000006
bcmwls32.exe,,,	0x00000006

[app.deldirs]
; Flags are 1=FLG_DEL_DIR_FORCE, 0=FLG_DEL_DIR_IF_EMPTY
"%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver", 0x00000001
"%16422%\Broadcom\Broadcom 802.11 Network Adapter"
"%16422%\Broadcom"

[install.addreg]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Entries for uninstall
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",UninstallString,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\bcmwlu00.exe"" verbose /rootkey=""Software\Broadcom\802.11\UninstallInfo"" /rootdir=""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver"""
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",DisplayName,0,"%OEM_SHORTCUT_NAME%"
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",DisplayIcon,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\bcmwlu00.exe"""
; Extended uninstall entries
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",InstallLocation,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver"""
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",MajorVersion,0x00010001,5
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",MinorVersion,0x00010001,60
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",DisplayVersion,0,"5.60.48.44"
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",NoModify,0x00010001,1
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",NoRepair,0x00010001,1
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",Publisher,0,"Broadcom Corporation"

[addremove.addreg.amd64]
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",UpgradeString,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\bcmwls64.exe"" upgrade"
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",QuietUninstallString,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\bcmwls64.exe"" uninstall"

[addremove.addreg]
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",UpgradeString,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\bcmwls32.exe"" upgrade"
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",QuietUninstallString,0,"""%16422%\Broadcom\Broadcom 802.11 Network Adapter\Driver\bcmwls32.exe"" uninstall"

[install.delreg]
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\%OEM_SHORTCUT_NAME%",,0x00002000

[gsmu.upgrade]
; Each line in this section is processed in order until a match is
; found. First the registry value at the key given in the first and
; second fields is stricmp() compared with value in third field. If it
; matches, the company name and version number from the version
; resource are compared against the fourth field and fifth fields. If
; the file version is lesser than or equal, the actions in the section
; given by the key are added to the queue.
; Run the latest uninstaller, note special "Run" command
UpgradeRun,,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11b Network Adapter",UpgradeString,,,,,
; Catch all old uninstallers
Upgrade,gsmu,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11b Network Adapter",UninstallString,%11%\BCMWLU00.exe, "verbose",,,

[gsmu.app.upgrade]
UpgradeRun,,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11 Application",UpgradeString,,,,,
Upgrade,gsmu.app,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11 Application",UninstallString,%11%\BCMWLU00.exe,"verbose /rootkey=Software\Broadcom\802.11_App\UninstallInfo",,,

[gsmu.driver.upgrade]
Upgrade,gsmu,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11b Network Adapter",UninstallString,%11%\BCMWLU00.exe,"verbose /rootkey=Software\Broadcom\802.11\UninstallInfo",,,

[gsmu]
PreRun=gsmu.services
DelReg=gsmu.delreg
RegDelFiles=SOFTWARE\Broadcom\802.11\UninstallInfo\InstalledFiles

[gsmu.app]
PreRun=gsmu.app.services
DelReg=gsmu.app.delreg
RegDelFiles=SOFTWARE\Broadcom\802.11_App\UninstallInfo\InstalledFiles

[gsmu.services]
"%11%\BCMWLU00.exe services /rootkey=SOFTWARE\Broadcom\802.11\UninstallInfo", 0x04
"%11%\BCMWLU00.exe preupdate /rootkey=SOFTWARE\Broadcom\802.11\UninstallInfo", 0x04

[gsmu.app.services]
"%11%\BCMWLU00.exe services /rootkey=SOFTWARE\Broadcom\802.11_App\UninstallInfo", 0x04
"%11%\BCMWLU00.exe preupdate /rootkey=SOFTWARE\Broadcom\802.11_App\UninstallInfo", 0x04

[gsmu.delreg]
HKLM,"SOFTWARE\Broadcom\802.11\UninstallInfo",,0x00002000
HKLM,"SOFTWARE\Broadcom\802.11",SupportedApps,0x00002000
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11b Network Adapter",,0x00002000

[gsmu.app.delreg]
HKLM,"SOFTWARE\Broadcom\802.11_App\UninstallInfo",,0x00002000
HKLM,"Software\Microsoft\Windows\CurrentVersion\Uninstall\Broadcom 802.11 Application",,0x00002000

[DestinationDirs]
help.copyfiles=18
help.copyfiles.0006=18,MUI\0006
help.copyfiles.0007=18,MUI\0007
help.copyfiles.0008=18,MUI\0008
help.copyfiles.0009=18,MUI\0009
help.copyfiles.000a=18,MUI\000a
help.copyfiles.000b=18,MUI\000b
help.copyfiles.000e=18,MUI\000e
help.copyfiles.0010=18,MUI\0010
help.copyfiles.0011=18,MUI\0011
help.copyfiles.0012=18,MUI\0012
help.copyfiles.0013=18,MUI\0013
help.copyfiles.0014=18,MUI\0014
help.copyfiles.0015=18,MUI\0015
help.copyfiles.0019=18,MUI\0019
help.copyfiles.001d=18,MUI\001d
help.copyfiles.001e=18,MUI\001e
help.copyfiles.001f=18,MUI\001f
help.copyfiles.0404=18,MUI\0404
help.copyfiles.040c=18,MUI\040c
help.copyfiles.0416=18,MUI\0416
help.copyfiles.0804=18,MUI\0804
help.copyfiles.0816=18,MUI\0816
help.copyfiles.0c04=18,MUI\0c04
app.copyfiles.SysWow64=10,SysWow64
app.copyfiles.system.SysWow64=10,SysWow64
DefaultDestDir=11
install.copyfiles.amd64=16422,Broadcom\Broadcom 802.11 Network Adapter\Driver
install.copyfiles=16422,Broadcom\Broadcom 802.11 Network Adapter\Driver

[SourceDisksNames]
2="Broadcom 802.11 Help Install Disk",bcmwlhlp.cab
1="Broadcom 802.11 Application Install Disk"

[SourceDisksFiles]
bcmwlhlp.chm=1
bcm0006.chm=2
bcm0007.chm=2
bcm0008.chm=2
bcm0009.chm=2
bcm000a.chm=2
bcm000b.chm=2
bcm000e.chm=2
bcm0010.chm=2
bcm0011.chm=2
bcm0012.chm=2
bcm0013.chm=2
bcm0014.chm=2
bcm0015.chm=2
bcm0019.chm=2
bcm001d.chm=2
bcm001e.chm=2
bcm001f.chm=2
bcm0404.chm=2
bcm040c.chm=2
bcm0416.chm=2
bcm0804.chm=2
bcm0816.chm=2
bcm0c04.chm=2
vcredist_x86.exe=1
vcredist_x86.bat=1
vcredist_x64.exe=1
vcredist_x64.bat=1
bcm1xsup.dll=1
WLBCGCBPRO731.DLL=1
;wl.exe=1
bcmwlu00.exe=1
bcmwls32.exe=1
bcmwls64.exe=1
[help.copyfiles]
bcmwlhlp.chm,,, 0x00000006

[help.copyfiles.0006] 
bcmwlhlp.chm,bcm0006.chm,,0x00000006
[help.copyfiles.0007] 
bcmwlhlp.chm,bcm0007.chm,,0x00000006
[help.copyfiles.0008] 
bcmwlhlp.chm,bcm0008.chm,,0x00000006
[help.copyfiles.0009] 
bcmwlhlp.chm,bcm0009.chm,,0x00000006
[help.copyfiles.000a] 
bcmwlhlp.chm,bcm000a.chm,,0x00000006
[help.copyfiles.000b] 
bcmwlhlp.chm,bcm000b.chm,,0x00000006
[help.copyfiles.000e] 
bcmwlhlp.chm,bcm000e.chm,,0x00000006
[help.copyfiles.0010] 
bcmwlhlp.chm,bcm0010.chm,,0x00000006
[help.copyfiles.0011] 
bcmwlhlp.chm,bcm0011.chm,,0x00000006
[help.copyfiles.0012] 
bcmwlhlp.chm,bcm0012.chm,,0x00000006
[help.copyfiles.0013] 
bcmwlhlp.chm,bcm0013.chm,,0x00000006
[help.copyfiles.0014] 
bcmwlhlp.chm,bcm0014.chm,,0x00000006
[help.copyfiles.0015] 
bcmwlhlp.chm,bcm0015.chm,,0x00000006
[help.copyfiles.0019] 
bcmwlhlp.chm,bcm0019.chm,,0x00000006
[help.copyfiles.001d] 
bcmwlhlp.chm,bcm001d.chm,,0x00000006
[help.copyfiles.001e] 
bcmwlhlp.chm,bcm001e.chm,,0x00000006
[help.copyfiles.001f] 
bcmwlhlp.chm,bcm001f.chm,,0x00000006
[help.copyfiles.0404] 
bcmwlhlp.chm,bcm0404.chm,,0x00000006
[help.copyfiles.040c] 
bcmwlhlp.chm,bcm040c.chm,,0x00000006
[help.copyfiles.0416] 
bcmwlhlp.chm,bcm0416.chm,,0x00000006
[help.copyfiles.0804] 
bcmwlhlp.chm,bcm0804.chm,,0x00000006
[help.copyfiles.0816] 
bcmwlhlp.chm,bcm0816.chm,,0x00000006
[help.copyfiles.0c04]
bcmwlhlp.chm,bcm0c04.chm,,0x00000006

[strings]
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"


[strings.2c01] 
OEM_SHORTCUT_NAME="محول شبكة الاتصال Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0401] 
OEM_SHORTCUT_NAME="محول شبكة الاتصال Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.3801] 
OEM_SHORTCUT_NAME="محول شبكة الاتصال Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0416] 
OEM_SHORTCUT_NAME="Adaptador de rede Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0416"

[strings.0402] 
OEM_SHORTCUT_NAME="Broadcom 802.11 мрежов адаптер"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0804] 
OEM_SHORTCUT_NAME="Broadcom 802.11 网络适配器"
LocalizedHelpSection = "help.copyfiles.0804"

[strings.1004] 
OEM_SHORTCUT_NAME="Broadcom 802.11 网络适配器"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0c04] 
OEM_SHORTCUT_NAME="Broadcom 802.11 網路卡"
LocalizedHelpSection = "help.copyfiles.0c04"

[strings.0404] 
OEM_SHORTCUT_NAME="Broadcom 802.11 網路卡"
LocalizedHelpSection = "help.copyfiles.0404"

[strings.041a] 
OEM_SHORTCUT_NAME="Broadcom 802.11 mrežni adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0405] 
OEM_SHORTCUT_NAME="Síťový adaptér Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0406] 
OEM_SHORTCUT_NAME="Broadcom 802.11 netværksadapter"
LocalizedHelpSection = "help.copyfiles.0006"

[strings.0813] 
OEM_SHORTCUT_NAME="Broadcom 802.11-netwerkadapter"
LocalizedHelpSection = "help.copyfiles.0013"

[strings.0413] 
OEM_SHORTCUT_NAME="Broadcom 802.11-netwerkadapter"
LocalizedHelpSection = "help.copyfiles.0013"

[strings.0c09] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.1009] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.040f] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0421] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.1809] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.043e] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.1409] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.3409] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.1c09] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0809] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0409] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Network Adapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0425] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Võrguadapter"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.040b] 
OEM_SHORTCUT_NAME="Broadcom 802.11 -verkkosovitin"
LocalizedHelpSection = "help.copyfiles.000b"

[strings.0c0c] 
OEM_SHORTCUT_NAME="Carte réseau Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.040c] 
OEM_SHORTCUT_NAME="Carte réseau Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.040c"

[strings.180c] 
OEM_SHORTCUT_NAME="Carte réseau Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.100c] 
OEM_SHORTCUT_NAME="Carte réseau Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0c07] 
OEM_SHORTCUT_NAME="Broadcom 802.11-Netzwerkadapter"
LocalizedHelpSection = "help.copyfiles.0007"

[strings.0407] 
OEM_SHORTCUT_NAME="Broadcom 802.11-Netzwerkadapter"
LocalizedHelpSection = "help.copyfiles.0007"

[strings.1407] 
OEM_SHORTCUT_NAME="Broadcom 802.11-Netzwerkadapter"
LocalizedHelpSection = "help.copyfiles.0007"

[strings.1007] 
OEM_SHORTCUT_NAME="Broadcom 802.11-Netzwerkadapter"
LocalizedHelpSection = "help.copyfiles.0007"

[strings.0807] 
OEM_SHORTCUT_NAME="Broadcom 802.11-Netzwerkadapter"
LocalizedHelpSection = "help.copyfiles.0007"

[strings.0408] 
OEM_SHORTCUT_NAME="Προσαρμογέας δικτύου Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0008"

[strings.040d] 
OEM_SHORTCUT_NAME="מתאם רשת Broadcom 802.11 "
LocalizedHelpSection = "help.copyfiles.0009"

[strings.040e] 
OEM_SHORTCUT_NAME="Broadcom 802.11 hálózati adapter"
LocalizedHelpSection = "help.copyfiles.000e"

[strings.0410] 
OEM_SHORTCUT_NAME="Scheda di rete Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0010"

[strings.0810] 
OEM_SHORTCUT_NAME="Scheda di rete Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0010"

[strings.0411] 
OEM_SHORTCUT_NAME="Broadcom 802.11 ネットワーク アダプタ"
LocalizedHelpSection = "help.copyfiles.0011"

[strings.0412] 
OEM_SHORTCUT_NAME="Broadcom 802.11 네트워크 어댑터"
LocalizedHelpSection = "help.copyfiles.0012"

[strings.0426] 
OEM_SHORTCUT_NAME="Broadcom 802.11 tīkla adapteris"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0427] 
OEM_SHORTCUT_NAME="Broadcom 802.11 tinklo adapteris"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0414] 
OEM_SHORTCUT_NAME="Broadcom 802.11 nettverkskort"
LocalizedHelpSection = "help.copyfiles.0014"

[strings.0415] 
OEM_SHORTCUT_NAME="Karta sieciowa Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0015"

[strings.0816] 
OEM_SHORTCUT_NAME="Placa de Rede Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0816"

[strings.0418] 
OEM_SHORTCUT_NAME="Adaptor de reţea Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0419] 
OEM_SHORTCUT_NAME="Сетевой адаптер Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0019"

[strings.041b] 
OEM_SHORTCUT_NAME="Sieťový adaptér Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.0424] 
OEM_SHORTCUT_NAME="Omrežni adapter Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.0009"

[strings.2c0a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.400a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.340a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.240a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.300a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.080a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.180a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.280a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.0c0a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.380a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.200a] 
OEM_SHORTCUT_NAME="Adaptador de red Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.000a"

[strings.041d] 
OEM_SHORTCUT_NAME="Broadcom 802.11 Nätverksadapter"
LocalizedHelpSection = "help.copyfiles.001d"

[strings.041e] 
OEM_SHORTCUT_NAME="อะแดปเตอร์เครือข่าย Broadcom 802.11"
LocalizedHelpSection = "help.copyfiles.001e"

[strings.041f]
OEM_SHORTCUT_NAME="Broadcom 802.11 Ağ Bağdaştırıcı"
LocalizedHelpSection = "help.copyfiles.001f"
